package Modules::Google;
#----------------------------------------------------------------------------
#   This plug-in uses HTML adapted from http://www.google.com/searchcode.html
#   That HTML code is Copyright Google.
#-----------------------------------------------------------------------
#
#   Everything else is:
#   Copyright 2001-2004 Exware Solutions, Inc.  http://www.exware.com
#
#   This file is part of ExSite WebWare (ExSite, for short).
#
#   ExSite is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   ExSite is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with ExSite; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#   Users requiring warranty coverage and/or support may arrange alternate
#   commercial licensing for ExSite, by contacting Exware Solutions 
#   via the website noted above.
#
#-----------------------------------------------------------------------

use strict;
use ExSite::Config;
use ExSite::Section;

# inherit from BaseDCD class
use Modules::BaseDCD;
use vars qw(@ISA);
@ISA = qw(Modules::BaseDCD);

sub write {
    my ($this,$options) = @_;
    my $url = $options;
    my $site = $share{DB}->this_site;
    if ($url || $site) {
	if (! $url) {
	    my $section = new ExSite::Section(section=>$site);
	    $url = $section->get_url;
	}
	if ($url) {
	    return "<!-- SiteSearch Google -->
<FORM method=GET action=\"http://www.google.com/search\" target=\"Google\">
<input type=hidden name=ie value=ISO-8859-1>
<input type=hidden name=oe value=ISO-8859-1>
<TABLE bgcolor=\"#FFFFFF\"><tr><td>
<A HREF=\"http://www.google.com/\">
<IMG SRC=\"http://www.google.com/logos/Logo_40wht.gif\" border=\"0\" ALT=\"Google\"></A>
</td><td>
<INPUT TYPE=text name=q size=31 maxlength=255 value=\"\">
<INPUT type=submit name=btnG VALUE=\"Google Search\">
<font size=-1>
<input type=hidden name=domains value=\"$url\"><br><input type=radio name=sitesearch value=\"\"> WWW <input type=radio name=sitesearch value=\"$url\" checked> $url <br>
</font>
</td></tr></TABLE>
</FORM>
<!-- SiteSearch Google -->\n";
	}
    }
    return "";
}

sub ioctl {
    my $this = shift;
    $_ = shift;   # $_ is the ioctl request
    if (/ModuleInfo/) {
	return "The Google applet places a google search box into the
page, allowing you to search the web, or just your website.  Note that
Google can only search your website after it has had a chance to crawl
your pages, and it make take some time for that to happen.  Thus, you
may initially find no search results for your site.";
    }
    return;
}

1;

