#!/usr/bin/perl
#---------------------------------------------------------------------
# dlg_table.cgi: custom dialog used by HTML editor for creating tables
#---------------------------------------------------------------------
#
#   Copyright 2001-2004 Exware Solutions, Inc.  http://www.exware.com
#
#   This file is part of ExSite WebWare (ExSite, for short).
#
#   ExSite is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   ExSite is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with ExSite; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#   Users requiring warranty coverage and/or support may arrange alternate
#   commercial licensing for ExSite, by contacting Exware Solutions 
#   via the website noted above.
#
#----------------------------------------------------------------------------

use strict;
use ExSite::Config;
use ExSite::Misc;
use ExSite::DB;
use myConfig; 
use vars qw(%data $access $db $OUT);

&exsite_init;
%data = &DecodeInput;
$db = new ExSite::DB;
$access = $db->authorize;

if (!$access){print "Location: login.cgi\n\n";}
elsif ($access < 2)
{
	$OUT .= &PrintHeader;
	$OUT .= "<p>Access Denied.  Webmasters only.</p>";
	$OUT .= &PrintFooter;
	print $OUT;
}
else
{
	$OUT .= &PrintHeader;
	$OUT .= &PrintForm;
	$OUT .= &PrintFooter;
	print $OUT;
}
#------------------------------------------------------------
sub PrintHeader{
	my $out = "content-type: text/html\n\n
<html>
<head>
<title>Insert Table</title>";
	if ($ENV{'HTTP_USER_AGENT'} =~ /msie/i){
	$out .= "
<style>
        BODY { background-color: buttonface; }
        TD, INPUT, SELECT { font-family: \"MS Sans Serif\"; font-size: xx-small; vertical-align: middle; }
        TABLE.dlg { border:0; }
        .dlg TD { horizontal-align: left; height: 20px; }
        .dlg INPUT { border-size: 2px; }
        INPUT.button { border-top: 1px solid white; border-left: 1px solid white;
                border-bottom: 1px solid black; border-right: 1px solid black;
                font-size: x-small; width: 60px; }
        SELECT { height: 75%; }
</style>";
	} else {        
	$out .= "
<style>
        BODY { background-color: buttonface; }
        TD, INPUT, SELECT, P { font-family: sans-serif; font-size: small; vertical-align: middle; }
        TABLE.dlg { border:0; }
        .dlg TD { horizontal-align: left; height: 20px; }
        .dlg INPUT { border-size: 2px; }
        INPUT.button_style { 
                border-top: 1px solid white; 
                border-left: 1px solid white;
                border-bottom: 1px solid black; 
                border-right: 1px solid black;
                font-size: x-small; 
                width: 60px; }
//        SELECT { height: 75%; }
</style>";
	}
	$out .= "
<script language=\"JavaScript\">
	function insertTable() {
		var myForm,rows,cols,border,bordercolor,cellspacing,cellpadding,bgcolor,tdwidth,tdheight,tdvalign,tdalign,table_class;
		myForm = document.forms[0];
		rows = myForm.rows.value ? parseInt(myForm.rows.value) : 2;
		cols = myForm.cols.value ? parseInt(myForm.cols.value) : 2;
		border = myForm.borderWidth.value;
		bordercolor = myForm.borderColor.value;
		cellspacing = myForm.cellSpacing.value;
		cellpadding = myForm.cellPadding.value;
		bgcolor = myForm.backgroundColor.value;
		tdwidth = myForm.colWidth.value;
		tdheight = myForm.rowHeight.value;
		tdvalign = myForm.vAlign.value;
		tdalign = myForm.Align.value;
		table_class = myForm.table_class.value;
                window.opener.getTable(table_class,rows,cols,border,bordercolor,cellspacing,cellpadding,bgcolor,tdwidth,tdheight,tdvalign,tdalign);
                window.close();
        }
        function cancel() {
                window.returnValue = null;
                window.close();
        }
</script>
</head>
<body topmargin=\"0\" leftmargin=\"0\" style=\"border: 0; margin: 0;\" scroll=\"no\">
";
	return $out;
}
sub PrintForm{
	my $out = "
<form>
<table border=\"0\" class=\"dlg\" cellpadding=\"0\" cellspacing=\"2\">
<tr>
 <td colspan=\"5\">
 <table width=\"100%\">
  <tr>
   <td>Layout</td><td valign=\"middle\" width=\"90%\"><hr width=\"100%\"></td>
  </tr>
  </table>
 </td>
</tr>
<tr>
 <td width=\"10\">&nbsp;</td>
 <td width=\"70\">Rows:</td><td valign=\"middle\"><input type=\"text\" name=\"rows\" value=\"2\" size=\"5\"></td>
 <td width=\"70\">Cell Padding:</td><td valign=\"middle\"><input type=\"text\" name=\"cellPadding\" value=\"\" size=\"5\"></td>
</tr>
<tr>          	    		
 <td>&nbsp;</td>
 <td>Columns:</td><td valign=\"middle\"><input type=\"text\" name=\"cols\" value=\"2\" size=\"5\"></td>
 <td>Cell Spacing:</td><td valign=\"middle\"><input type=\"text\" name=\"cellSpacing\" value=\"\" size=\"5\"></td>
</tr>
<tr>
 <td>&nbsp;</td>
 <td>Row Height:</td><td valign=\"middle\"><input type=\"text\" name=\"rowHeight\" value=\"\" size=\"5\"></td>
 <td>Vertical Alignment:</td>
 <td valign=\"middle\">
  <select name=\"vAlign\">
   <option value=\"\">== Select ==</option>
   <option value=\"top\">Top</option>
   <option value=\"middle\">Middle</option>
   <option value=\"bottom\">Bottom</option>
  </select>
 </td> 
</tr>
<tr>
 <td>&nbsp;</td>
 <td>Column Width:</td><td valign=\"middle\"><input type=\"text\" name=\"colWidth\" value=\"\" size=\"5\"></td>
 <td>Horizontal Alignment:</td>
 <td valign=\"middle\">
  <select name=\"Align\">
   <option value=\"\">== Select ==</option> 
   <option value=\"left\">Left</option>
   <option value=\"center\">Center</option>
   <option value=\"right\">Right</option>
  </select>
 </td>
</tr>
<tr>
 <td colspan=\"5\">
  <table width=\"100%\">
  <tr>
   <td>Borders</td>
   <td valign=\"middle\" width=\"90%\"><hr width=\"100%\"></td>
  </tr>
  </table>
 </td>
</tr>
<tr>
 <td>&nbsp;</td>
 <td>Width:</td><td valign=\"middle\"><input type=\"text\" name=\"borderWidth\" value=\"\" size=\"5\"></td>
 <td>Color:</td><td valign=\"middle\"><input type=\"text\" name=\"borderColor\" value=\"\" size=\"10\"></td>
</tr>
<tr>
 <td colspan=\"5\">
  <table width=\"100%\">
  <tr>
   <td>Background</td>
   <td valign=\"middle\" width=\"90%\"><hr width=\"100%\"></td>
  </tr>
  </table>
 </td>
</tr>
<tr>
 <td>&nbsp;</td>
 <td>Color:</td>
 <td valign=\"middle\"><input type=\"text\" name=\"backgroundColor\" value=\"\" size=\"15\"></td>
 <td colspan=\"2\"> (Enter color name or HTML RGB code)</td>
</tr>
<tr><td colspan=\"5\"><table width=\"100%\"><tr><td valign=\"middle\" width=\"100%\" colspan=\"2\"><hr width=\"100%\"></td></tr></table></td></tr>
<tr>
 <td>&nbsp;</td>
 <td>CSS Class:</td>
 <td><input type=\"text\" name=\"table_class\" value=\"\" size=\"10\"></td>
 <td colspan=\"2\" align=\"right\">
  <input class=\"button\" type=\"button\" value=\"Insert\" title=\"Insert Table\" onclick=\"insertTable()\">
  <input class=\"button\" type=\"button\" value=\"Cancel\" title=\"Cancel Dialog\" onclick=\"cancel()\">
 </td>
</tr>
</table>
</form>
";
	return $out;
}

sub PrintFooter{
	return "
</body>
</html>
";
}
