#!/usr/bin/perl

use strict;
use ExSite::Config;
use ExSite::Misc;
use ExSite::DB;
use myConfig; 
use vars qw(%data $access $db $OUT $file);

&exsite_init;
%data = &DecodeInput;
$db = new ExSite::DB;
$access = $db->authorize;
$file = "dlg_table_editor.cgi";

if (!$access){
	print "Location: login.cgi\n\n";
}elsif ($access < 2){
	$OUT .= &PrintHeader;
	$OUT .= "<p>Access Denied.  Webmasters only.</p>";
	$OUT .= &PrintFooter;
	print $OUT;
}else{
	if ($data{get_form} eq "table"){
		print "content-type: text/html\n\n".&PrintFormTable();
	}elsif ($data{get_form} eq "row"){
		print "content-type: text/html\n\n".&PrintFormRow();
	}elsif ($data{get_form} eq "column"){
		print "content-type: text/html\n\n".&PrintFormColumn();
	}elsif ($data{get_form} eq "cell"){
		print "content-type: text/html\n\n".&PrintFormCell();
	}else{
		$OUT .= &PrintHeader;
		$OUT .= &PrintForm;
		$OUT .= &PrintFooter;
		print $OUT;
	}
}
#------------------------------------------------------------
sub PrintHeader{
	my $out = "content-type: text/html\n\n
<html>
<head>
<title>Row Properties</title>
<style>";
	if ($ENV{'HTTP_USER_AGENT'} =~ /msie/i){
	$out .= "
        TD, INPUT, SELECT { font-family: \"MS Sans Serif\"; font-size: xx-small; vertical-align: middle; }";
	} else {        
	$out .= "
        TD, INPUT, SELECT, P { font-family: sans-serif; font-size: small; vertical-align: middle; }";
	}
	$out .= "
	body {
		border: 0;
		margin: 0;
		background-color: #ccccdd;
	}
	.tab_body {
		background-color: #e0e0f0;
		border-left:1px solid;
		border-bottom:1px solid;
		border-right:1px solid;
	}
	.tab_cell {
		height: 20px;
		width: 80px;
	}
	.tab_blank {
		height: 20px;
		width: 5;
   		border-bottom:1px solid black;
	}
	.tab_blank_last {
		height: 20px;
		border-bottom:1px solid black;
	}
	.tab_form {
		border:1px solid black;
		background-color:#f0f0ff;
		width: 90%;
	}
	.tab_form th {
		font-size: x-small;
		background-color:#333344;
		color:#e0e0f0;
		padding:4px;
	}
	.tab_form td {
		font-size: x-small;
		padding:4px;
	}
	.blank_cell {
		width: 5;
	}
	.tab_button {
		width: 90%;
	}
	.tab_button td {
		align: right;
	}
	.form_label {
		width: 70;
	}
</style>
<script language=\"JavaScript\" src=\"$config{server}{HTMLpath}/_ExSite/js/editor.js\"></script>
<script language=\"JavaScript\">
<!--
	var inactiveColor = '#bbbbcc';
	var selectedColor = '#e0e0f0';
	var oldSelect = window.opener.getEditorRange(window.opener.getEditorSelection());
	// checks cursor position
	function checkCursorPosition(){		
		setTimeout(\"checkCursorPosition()\",500);
		checkCursor();		
	}
	// check cursor position
	function checkCursor(){
		// get cursor position
		var sel = window.opener.getEditorSelection();
		var currSelect = window.opener.getEditorRange(sel);
		// get the table cell that is selected by the cursor
		var currCell = window.opener.getClosest('td') || window.opener.getClosest('th');
		var cell_changed = 0;
		// no table cell is selected. close the table editor.
		if (!currCell){
			window.close();
			return;
		}
		// check and see if the user selects a different table cell
		if (isIE()){
			if (!currSelect.isEqual(oldSelect)){
				cell_changed = 1;
			}
		}else{
			if (currSelect.compareBoundaryPoints('START_TO_END',oldSelect) != 0){
				cell_changed = 1;
			}
		}
		// update the table editor with the newly selected table cell data
		if (cell_changed){
			oldSelect = currSelect;
			window.location.reload();
		}
	}
	// close the popup when the user clicks on the 'cancel' button
        function cancel() {
                window.returnValue = null;
                window.close();
        }
	// by default the table editor shows cell properties
	function initWindow(){
		selectTab('tab_cell');
	}
	// reset table color
	function resetTabColor(){
		var tabs = new Array('tab_table','tab_row','tab_column','tab_cell');
		for(var i = 0; i < tabs.length; i++){
			var myCell = document.getElementById(tabs[i]);			
			myCell.style.borderWidth = '1';
			myCell.style.borderBottom = '1px solid';
			myCell.width = '80';
			myCell.bgColor = inactiveColor;
			myCell.style.borderTop = '1px solid';
			myCell.style.borderLeft = '1px solid';
			myCell.style.borderRight = '1px solid';				
		}
	}
	// dhtml tab effects
	function selectTab(id){
		if (id == ''){
			return;
		}
		resetTabColor();
		var selTab = document.getElementById(id);
		selTab.bgColor = selectedColor;
		selTab.style.borderBottom = 'none';
		populateDiv(id);
	}
	// populate the div with forms
	function populateDiv(id){
		var myDiv = document.getElementById('div_space');
		myDiv.innerHTML = '';
		switch(id){
			// row properties
			case 'tab_row':
				myDiv.innerHTML = getForm('row');
				populateRowForm();
				break;
			// column properties
			case 'tab_column':
				myDiv.innerHTML = getForm('column');
				populateColumnForm();
				break;
			// cell properties
			case 'tab_cell':
				myDiv.innerHTML = getForm('cell');
				populateCellForm();
				break;
			// table properties
			default:
				myDiv.innerHTML = getForm('table');
				populateTableForm();
				break;
		}
	}
	// populate form information for dhtml
	function getForm(type){
		var myForm,inputforms;
		inputforms = new Object();
		inputforms['row'] = '".&getInputForm("row")."';
		inputforms['column'] = '".&getInputForm("column")."';
		inputforms['cell'] = '".&getInputForm("cell")."';
		inputforms['table'] = '".&getInputForm("table")."';
		myForm = inputforms[type];
		return myForm;
	}
	// delete a table, a row, a column or a cell
	function deleteTable(type){
		if (confirm('Are you sure you want to delete this ' + type + '?')){
			switch(type){
			// delete a row
			case 'row':			
				window.opener.doDeleteRow();
				break;
			// delete a column
			case 'column':
				window.opener.doDeleteColumn();
				break;
			// delete a cell
			case 'cell':
				window.opener.doDeleteCell();
				break;
			// delete a table
			case 'table':
				window.opener.deleteTable();
				break;
			}
		}
	}
	// update table properties
	function updateTable(){
		updateTableProperty();
		window.close();
	}
	// update row properties
	function updateRow(){
		updateRowProperty();
		window.close();
	}
	// update column properties
	function updateColumn(){
		updateColumnProperty();
		window.close();
	}
	// update cell properties
	function updateCell(){
		updateCellProperty();
		window.close();
	}
	// insert a 'th' before
	function insertHeaderRowBefore(){
		updateRowProperty();
		window.opener.doInsertRow('before','th');		
	}
	// insert a 'tr' before
	function insertRowBefore(){
		updateRowProperty();
		window.opener.doInsertRow('before','td');		
	}
	// insert a 'tr' after
	function insertRowAfter(){
		updateRowProperty();
		window.opener.doInsertRow('after','td');		
	}
	// insert a column before
	function insertColumnBefore(){
		updateColumnProperty();
		window.opener.doInsertColumn('before');		
	}
	// insert a column after
	function insertColumnAfter(){
		updateColumnProperty();
		window.opener.doInsertColumn('after');		
	}
	// insert a 'td' before
	function insertCellBefore(){
		updateCellProperty();
		window.opener.doInsertCell('before');		
	}
	// insert a 'td' after
	function insertCellAfter(){
		updateCellProperty();
		window.opener.doInsertCell('after');		
	}
	// update cell properties
	function updateCellProperty() {
		var myForm,height,width,table_class,valign,align,rowspan,colspan,bgcolor,nowrap;
		myForm = document.forms[0];
		height = myForm.rowHeight.value;
		width = myForm.colWidth.value;
		align = myForm.Align.value;
		valign = myForm.vAlign.value;
		rowspan = myForm.rowSpan.value;
		colspan = myForm.colSpan.value;
		bgcolor = myForm.backgroundColor.value;
		table_class = myForm.table_class.value;
		nowrap = myForm.nowrap.checked ? 1 : 0;
                window.opener.getPropertyCell(table_class,height,width,align,valign,rowspan,colspan,bgcolor,nowrap);
        }
	// populate cell form
	function populateCellForm(){
		var cell = window.opener.getClosest(\"td\") || window.opener.getClosest(\"th\");		
		document.forms[0].rowHeight.value = cell.height;
		document.forms[0].colWidth.value = cell.width;
		document.forms[0].vAlign.value = cell.vAlign;
		document.forms[0].Align.value = cell.align;
		document.forms[0].rowSpan.value = cell.rowSpan;
		document.forms[0].colSpan.value = cell.colSpan;
		document.forms[0].backgroundColor.value = cell.bgColor;
		document.forms[0].table_class.value = cell.className;
		document.forms[0].nowrap.checked = cell.noWrap;
	}
	// update row properties
	function updateRowProperty() {
		var myForm,table_class,valign,align,bgcolor;
		myForm = document.forms[0];
		align = myForm.Align.value;
		valign = myForm.vAlign.value;
		bgcolor = myForm.backgroundColor.value;
		table_class = myForm.table_class.value;
                window.opener.getPropertyRow(table_class,align,valign,bgcolor);
        }
	// populate row form
	function populateRowForm(){
		var row = window.opener.getClosest(\"tr\");
		document.forms[0].vAlign.value = row.vAlign;
		document.forms[0].Align.value = row.align;
		document.forms[0].backgroundColor.value = row.bgColor;
		document.forms[0].table_class.value = row.className;
	}
	// update column properties
	function updateColumnProperty() {
		var myForm,width,table_class,bgcolor,nowrap;
		myForm = document.forms[0];
		width = myForm.colWidth.value;
		bgcolor = myForm.backgroundColor.value;
		table_class = myForm.table_class.value;
		nowrap = myForm.nowrap.checked ? 1 : 0;
                window.opener.getPropertyColumn(table_class,width,bgcolor,nowrap);
        }
	// populate column form
	function populateColumnForm(){
		var cell = window.opener.getClosest(\"td\") || window.opener.getClosest(\"th\");		
		document.forms[0].colWidth.value = cell.width;
		document.forms[0].backgroundColor.value = cell.bgColor;
		document.forms[0].table_class.value = cell.className;
		document.forms[0].nowrap.checked = cell.noWrap;
	}
	// update table properties
	function updateTableProperty(){
		var myForm,padding,spacing,bwidth,bcolor,bgcolor,table_class,border;
		myForm = document.forms[0];
		border = myForm.borderWidth.value;
		padding = myForm.cellPadding.value;
		spacing = myForm.cellSpacing.value;
		bcolor = myForm.borderColor.value;
		bgcolor = myForm.backgroundColor.value;
		table_class = myForm.table_class.value;
		window.opener.getPropertyTable(table_class,border,padding,spacing,bwidth,bcolor,bgcolor);
	}
	// populate table form
	function populateTableForm(){
		var table = window.opener.getClosest(\"table\");
		document.forms[0].cellPadding.value = table.cellPadding;
		document.forms[0].cellSpacing.value = table.cellSpacing;
		document.forms[0].borderColor.value = table.getAttribute('borderColor');
		document.forms[0].backgroundColor.value = table.bgColor;
		document.forms[0].table_class.value = table.className;
		document.forms[0].borderWidth.value = table.border;
	}
// -->
</script>
</head>
<body topmargin=\"0\" leftmargin=\"0\" scroll=\"no\" onLoad=\"initWindow()\" style=\"background:#e0e0f0;\">
<script>
checkCursorPosition();
</script>
";
	return $out;
}
sub getInputForm{
	my ($type) = @_;
	my $inputform;
	if ($type eq "cell"){
		$inputform = &PrintFormCell();
	}elsif ($type eq "column"){
		$inputform = &PrintFormColumn();
	}elsif ($type eq "row"){
		$inputform = &PrintFormRow();
	}else{
		$inputform = &PrintFormTable();
	}
	$inputform =~ s/(\r)?\n//ig;
	$inputform =~ s/"/\\"/g;
	$inputform =~ s/'/\\'/g;
	return $inputform;
}
sub PrintForm{
	my $out = "
<table id=\"command_tab\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\" height=\"35\" border=\"0\" style=\"border-color:#000000;background:#ccccdd;\">
<tr><td><br></td></tr>
<tr>
	<td class=\"tab_blank\">&nbsp;</td>
	<td id=\"tab_table\" class=\"tab_cell\" onClick=\"selectTab(this.id)\">Table</td>
	<td class=\"tab_blank\">&nbsp;</td>
	<td id=\"tab_row\" class=\"tab_cell\" onClick=\"selectTab(this.id)\">Row</td>
	<td class=\"tab_blank\">&nbsp;</td>
	<td id=\"tab_column\" class=\"tab_cell\" onClick=\"selectTab(this.id)\">Column</td>
	<td class=\"tab_blank\">&nbsp;</td>
	<td id=\"tab_cell\" class=\"tab_cell\" onClick=\"selectTab(this.id)\">Cell</td>
	<td class=\"tab_blank_last\">&nbsp;</td>
</tr>
</table>
<br>
<div id=\"div_space\"><img src=\"$config{server}{HTMLpath}/_ExSite/images/null.gif\" width=\"500\" border=\"0\"></div>
";
	return $out;
}

sub PrintFooter{
	return "
</body>
</html>
";
}
sub PrintFormTable{
	my $out = "
<center>
<form>
<table class=\"tab_form\">
<tr> 
	<th colspan=\"5\">Layout</th>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Cell Padding:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"cellPadding\" value=\"\" size=\"10\"></td>
	<td class=\"form_label\">Cell Spacing:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"cellSpacing\" value=\"\" size=\"10\"></td>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Border Width:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"borderWidth\" value=\"\" size=\"10\"></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
</table>
<br>
<table class=\"tab_form\">
<tr>
	<th colspan=\"4\">Style</th>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Border Color:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"borderColor\" value=\"\" size=\"10\"></td>
	<td> (Enter color name or HTML RGB code)</td>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Background Color:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"backgroundColor\" value=\"\" size=\"10\"></td>
	<td> (Enter color name or HTML RGB code)</td>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">CSS Class:</td>
	<td><input type=\"text\" name=\"table_class\" value=\"\" size=\"10\"></td>
</tr>
</table>
<br>
<table class=\"tab_button\">
<tr>
	<td align=\"right\">
	<input type=\"button\" value=\"Apply\" title=\"Apply\" onclick=\"updateTableProperty()\">
	<input type=\"button\" value=\"Okay\" title=\"Okay\" onclick=\"updateTable()\">
	<input type=\"button\" value=\"Close\" title=\"Close Dialog\" onclick=\"cancel()\">
	<input type=\"button\" value=\"Delete\" title=\"Delete\" onclick=\"deleteTable('table')\">
	</td>
</tr>
</table>
</form>
</center>
";
	return $out;
}
sub PrintFormRow(){
	my $out = "
<center>
<form>
<table class=\"tab_form\">
<tr>
	<th colspan=\"5\">Layout</th>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Vertical Alignment:</td>
	<td valign=\"middle\">
		<select name=\"vAlign\">
		<option value=\"\">== Select ==</option>
		<option value=\"top\">Top</option>
		<option value=\"middle\">Middle</option>
		<option value=\"bottom\">Bottom</option>
		</select>
	</td> 
	<td class=\"form_label\">Horizontal Alignment:</td>
	<td valign=\"middle\">
		<select name=\"Align\">
		<option value=\"\">== Select ==</option> 
		<option value=\"left\">Left</option>
		<option value=\"center\">Center</option>
		<option value=\"right\">Right</option>
		</select>
	</td>
</tr>
</table>
<br>
<table class=\"tab_form\">
<tr>
	<th colspan=\"4\">Style</th>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Background Color:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"backgroundColor\" value=\"\" size=\"10\"></td>
	<td> (Enter color name or HTML RGB code)</td>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">CSS Class:</td>
	<td colspan=\"2\"><input type=\"text\" name=\"table_class\" value=\"\" size=\"10\"></td>
</tr>
</table>
<br>
<table class=\"tab_button\">
<tr>
	<td align=\"right\">
	<table>
	<tr>
		<td>
			<input type=\"button\" value=\"Insert a header row before\" title=\"Insert a headerrow before\" onclick=\"insertHeaderRowBefore()\">
		</td>
		<td colspan=\"2\">
			<input type=\"button\" value=\"Insert a row before\" title=\"Insert a row before\" onclick=\"insertRowBefore()\">
		</td>
		<td colspan=\"2\">
			<input type=\"button\" value=\"Insert a row after\" title=\"Insert a row after\" onclick=\"insertRowAfter()\">
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td align=\"left\">
			<input type=\"button\" value=\"Apply\" title=\"Apply\" onclick=\"updateRowProperty()\">
		</td>
		<td align=\"right\">
			<input type=\"button\" value=\"Okay\" title=\"Okay\" onclick=\"updateRow()\">
		</td>
		<td align=\"left\">
			<input type=\"button\" value=\"Close\" title=\"Close Dialog\" onclick=\"cancel()\">
		</td>
		<td align=\"right\">
			<input type=\"button\" value=\"Delete\" title=\"Delete\" onclick=\"deleteTable('row')\">
		</td>
	</tr>
	</table>
	</td>
</tr>
</table>
</form>
</center>
";
	return $out;
}
sub PrintFormColumn(){
	my $out = "
<center>
<form>
<table class=\"tab_form\">
<tr>
	<th colspan=\"5\">Layout</th>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Column Width:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"colWidth\" value=\"\" size=\"5\"></td>
	<td colspan=\"2\"><input type=\"checkbox\" name=\"nowrap\" value=\"\">No wrap</td>
</tr>
</table>
<br>
<table class=\"tab_form\">
<tr>
	<th colspan=\"5\">Style</th>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Background Color:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"backgroundColor\" value=\"\" size=\"10\"></td>
	<td colspan=\"2\"> (Enter color name or HTML RGB code)</td>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">CSS Class:</td>
	<td colspan=\"2\"><input type=\"text\" name=\"table_class\" value=\"\" size=\"10\"></td>
</tr>
</table>
<br>
<table class=\"tab_button\">
<tr>
<td align=\"right\">
	<table>
	<tr>
		<td colspan=\"2\">
			<input type=\"button\" value=\"Insert a column before\" title=\"Insert a column before\" onclick=\"insertColumnBefore()\">
		</td>
		<td colspan=\"2\">		
			<input type=\"button\" value=\"Insert a column after\" title=\"Insert a column after\" onclick=\"insertColumnAfter()\">
		</td>
	</tr>
	<tr>
		<td align=\"left\">
			<input type=\"button\" value=\"Apply\" title=\"Apply\" onclick=\"updateColumnProperty()\">
		</td>
		<td align=\"right\">
			<input type=\"button\" value=\"Okay\" title=\"Okay\" onclick=\"updateColumn()\">
		</td>
		<td align=\"left\">
			<input type=\"button\" value=\"Close\" title=\"Close Dialog\" onclick=\"cancel()\">
		</td>
		<td align=\"right\">
			<input type=\"button\" value=\"Delete\" title=\"Delete\" onclick=\"deleteTable('column')\">
		</td>
	</tr>
	</table>
</td>
</tr>
</table>
</form>
</center>
";
	return $out;
}
sub PrintFormCell(){
	my $out = "
<center>
<form>
<table class=\"tab_form\">
<tr>
	<th colspan=\"5\">Layout</th>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Row Height:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"rowHeight\" value=\"\" size=\"10\"></td>
	<td class=\"form_label\">Column Width:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"colWidth\" value=\"\" size=\"10\"></td>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Vertical Alignment:</td>
	<td valign=\"middle\">
		<select name=\"vAlign\">
		<option value=\"\">== Select ==</option>
		<option value=\"top\">Top</option>
		<option value=\"middle\">Middle</option>
		<option value=\"bottom\">Bottom</option>
		</select>
	</td> 
	<td class=\"form_label\">Horizontal Alignment:</td>
	<td valign=\"middle\">
		<select name=\"Align\">
		<option value=\"\">== Select ==</option> 
		<option value=\"left\">Left</option>
		<option value=\"center\">Center</option>
		<option value=\"right\">Right</option>
		</select>
	</td>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Row Span:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"rowSpan\" value=\"\" size=\"10\"></td>
	<td class=\"form_label\">Column Span:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"colSpan\" value=\"\" size=\"10\"></td>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td colspan=\"4\"><input type=\"checkbox\" name=\"nowrap\" value=\"\">&nbsp;No wrap</td>
</tr>
</table>
<br>
<table class=\"tab_form\">
<tr>
	<th colspan=\"4\">Style</th>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">Background Color:</td>
	<td valign=\"middle\"><input type=\"text\" name=\"backgroundColor\" value=\"\" size=\"15\"></td>
	<td> (Enter color name or HTML RGB code)</td>
</tr>
<tr>
	<td class=\"blank_cell\">&nbsp;</td>
	<td class=\"form_label\">CSS Class:</td>
	<td><input type=\"text\" name=\"table_class\" value=\"\" size=\"10\"></td>
	<td>&nbsp;</td>
</tr>
</table>
<br>
<table class=\"tab_button\">
<tr>
<td align=\"right\">
	<table border=\"0\">
	<tr>
		<td colspan=\"2\">
			<input type=\"button\" value=\"Insert a cell before\" title=\"Insert a cell before\" onclick=\"insertCellBefore()\">
		</td>
		<td colspan=\"2\">
		<input type=\"button\" value=\"Insert a cell after\" title=\"Insert a cell after\" onclick=\"insertCellAfter()\">
		</td>
	</tr>
	<tr>
		<td align=\"left\">
			<input type=\"button\" value=\"Apply\" title=\"Apply\" onclick=\"updateCellProperty()\">
		</td>
		<td align=\"right\">
			<input type=\"button\" value=\"Okay\" title=\"Okay\" onclick=\"updateCell()\">
		</td>
		<td align=\"left\">
			<input type=\"button\" value=\"Close\" title=\"Close Dialog\" onclick=\"cancel()\">
		</td>
		<td align=\"right\">
			<input type=\"button\" value=\"Delete\" title=\"Delete\" onclick=\"deleteTable('cell')\">
		</td>
	</tr>
	</table>
</td>
</tr>
</table>
</form>
</center>
";
	return $out;
}
