#!/usr/bin/perl
#-----------------------------------------------------------------------
# export.cgi - export data to other file formats
#-----------------------------------------------------------------------

use strict;
use ExSite::Config;
use ExSite::Report;
use ExSite::Misc;

&exsite_init;
$config{page_buffering}=0;
my $db = new ExSite::Report;

# fetch any query arguments

my %query = &DecodeInput;

my $table = $query{table}; 
my $format = $query{format}; 

my $access = $db->authorize;

if ($access >= 3) {
    my $gid=$db->my_gid;
    my $uid=$db->my_uid;
    # query for table/format on first pass
    if (!$table || !$format) {
	my %allowed_tables;
	foreach my $tab ($db->{map}->get_tables) {
	    if ($db->approve("read",$tab)) {
		$allowed_tables{$tab} = $db->{map}->table_title($tab,1);
	    }
	}
	&page_header("Export Data",$db);
	print "<H3>Export Data</H3>\n";
	print "<P>Select the table of data to export, and the format you want to receive the data in:</P>\n";
	print"<form method=post action=\"$config{server}->{CGIpath}/export.cgi/export\">\n";
	print"Table: <select name=table>\n";
	foreach (sort keys (%allowed_tables)) {
	    print"<option value=\"$_\">$allowed_tables{$_}</option>\n";
	}
	print"</select><br>\n"; 
	print"Format: <select name=format>\n";
	print"<option value=text>tab-delimited text file</option>\n";
	print"<option value=excel>MS-Excel (.xls) file</option>\n";
	print"</select><br>";
	print"<P><INPUT TYPE=submit value=Submit name=Submit> ";
	print "<INPUT TYPE=button value=Cancel name=Cancel onclick=\"javascript:history.back();\"> ";
	print "<INPUT TYPE=reset name=Reset>";
	print"</form>\n";
	&page_footer($db);
    }
    else {
	# do the export
	if ($format eq "text") {
	    print "Content-type: text/plain\n\n";
	}
	elsif ($format eq "excel") {
	    print "Content-type: application/vnd.ms-excel\n\n";
	}
	$db->export({table=>$table,format=>$format});
    }
}
else {
    &page_header("Export Data");
    print "<H3 CLASS=error>Export: Permission Denied</H3>\n";
    &page_footer($db);
}

### END

