#!/usr/bin/perl
#-----------------------------------------------------------------------
# exsite-help.cgi
#-----------------------------------------------------------------------

use strict;
use ExSite::Config;

&exsite_init;

my $fnf = 0;
my $helpurl;

if ($ENV{HTTP_REFERER}) {
    $ENV{HTTP_REFERER} =~ /ctrl-panel\.cgi\/(\w+)/;
    if (-e "$config{server}{HTMLroot}$config{server}{HTMLpath}/_Modules/$1/help.html") {

	# module-specific helpfile found

	$helpurl = "$config{server}{HTMLpath}/_Modules/$1/help.html";
    }
    elsif ($ENV{HTTP_REFERER} =~ /webdb\.cgi/) {
	if (-e "$config{server}{HTMLroot}$config{server}{HTMLpath}/_Modules/WebDB/help.html") {

	    # use WebDB filefile

	    $helpurl = "$config{server}{HTMLpath}/_Modules/WebDB/help.html";
	}
    }
}
if (! $helpurl && $config{help_url}) {
    if (-e "$config{server}{HTMLroot}$config{help_url}") {

	# use general system docs

	$helpurl = "$config{help_url}";
    }
}

if ($helpurl) {
    $| = 1;
    print "Content-type: text/html\n\n";
    print "<html><head><meta http-equiv=\"REFRESH\" CONTENT=\"0; URL='$helpurl'\"></head>\n";
    print "<body>\n<p>Redirecting you to <a href=$helpurl>help files</a>...</p>\n</body>\n</html>\n";
}
else {
    &page_header("ExSite Help");
    print "<h1 class=error>Documentation Not Found</h1>\n";
    print "<p class=error>The ExSite Help Documentation has not been installed 
on this website.  Please talk to your site administrator, or consult the 
ExSite Installation Guide for help.</p>\n";
    &page_footer;
}

### END

