#!/usr/bin/perl
#-----------------------------------------------------------------------
# exsite_log.cgi - review logs
#-----------------------------------------------------------------------

use strict;
use ExSite::Config;
use ExSite::DB;  # for authentication only
use ExSite::Misc;

use vars qw($db %query);

&exsite_init;
%query = &DecodeQuery;
$db = new ExSite::DB;
&page_header("ExSite Logger");

# what is being logged?

my @logs = ("db", "cms", "general");
#foreach my $key (keys %{$config{log}}) {
#    next if $key eq "logfile";
#    if ($config{log}{$key}) { push @logs, $key; }
#}

if ($db->authorize < $config{auth}{root_auth_level} - 1) {
    print "<h3 class=error>Permission denied.</h3>\n";
}
elsif (@logs == 0) {
    print "<h3 class=error>No logs are enabled.</h3>\n";
}
else {
    if (! $query{log}) {
	%query = ( log=>$logs[0], nlines=>25, format=>"formatted" );
    }
    print "<form method=GET>\n";
    print "Logfile: <select name=log onChange=submit()>\n";
    foreach my $log (@logs) {
	print "<option";
	if ($log eq $query{log}) { print " selected"; }
	print ">$log</option>\n";
    }
    print "</select>&nbsp;&nbsp;&nbsp;&#149;&nbsp;&nbsp;&nbsp;\n";
    print "Show last <select name=nlines onChange=submit()>\n";
    foreach my $nl (10,25,100,0) {
	print "<option value=$nl";
	if ($nl == $query{nlines}) { print " selected"; }
	if ($nl) { print ">$nl"; }
	else { print ">all"; }
	print "</option>\n";
    }
    print "</select>\nmessages&nbsp;&nbsp;&nbsp;&#149;&nbsp;&nbsp;&nbsp;\n";
    print "Formatting: <select name=format onChange=submit()><option";
    if ($query{format} eq "formatted") { print " selected"; }
    print ">formatted</option><option";
    if ($query{format} eq "unformatted") { print " selected"; }
    print ">unformatted</option></select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
    #print "<input type=submit>\n</form>\n<hr>\n";
    print "</form>\n<hr>\n";

    # show the logs
    
    my @logdata = $db->showlog($query{log},$query{nlines});
    if ($query{format} eq "unformatted") {
	print "<pre>\n",@logdata,"\n</pre>\n";
    }
    else {
	print "<table cellspacing=3 bgcolor=#FFFFFF class=framed>\n<tr><th>Time</th><th>User</th><th>Request</th><th>Message</th></tr>\n";
	foreach my $row (@logdata) {
	    my @rdat = split(/\t/,$row);
	    print "<tr><td>",join("</td><td>",@rdat),"</td></tr>\n";
	}
	print "</table>\n";
    }
}

&page_footer;

### END

