#!/usr/bin/perl
#-----------------------------------------------------------------------
# help.cgi - display help text 
#
# Usage: help.cgi/path/to/helpfile
#
# We look for the helpfile in 2 locations:  
# 1) CGIpath/dbmap/help
# 2) HTMLpath/_Modules/
#-----------------------------------------------------------------------

use strict;
use ExSite::Config;
use ExSite::Misc;

&exsite_init;

print "Content-type: text/html\n\n";

print "<HEAD>\n<TITLE>$config{site}->{name} Help</TITLE>\n";
print "<link REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"$config{server}{HTMLpath}/_ExSite/css/ExSite.css\">\n";
print "</HEAD>\n<BODY>\n";

my $helpfile = $ENV{PATH_INFO};
$helpfile =~ s/^\///;

print "<div align=center><table bgcolor=#FFFFFF cellpadding=10><tr><td>\n";
print "<DIV ALIGN=center><H3><IMG SRC=$config{server}->{HTMLpath}/_ExSite/images/qmark.gif HEIGHT=20 WIDTH=20><br>Help</H3></DIV>\n";

$helpfile =~ /^(dbmap\/help\/.*)$/;
my $safe_helpfile = $1;

if ($safe_helpfile) {
    # looks like a dbmap help file
    my $helptext = &get_file($safe_helpfile);
    print "<p class=help>$helptext</p>\n";
}
else {
    $helpfile =~ /^(_Modules\/.*\/help.html)$/;
    $safe_helpfile = $1;
    if ($safe_helpfile) {
	# looks like a module help file
	my $imgpath = $safe_helpfile;
	$imgpath =~ s/\/[^\/]*$//;
	my $helptext = &get_file("$config{server}{HTMLroot}$config{server}{HTMLpath}/$safe_helpfile",{imgpath=>"$config{server}{HTMLpath}/$imgpath"});
	print "<p class=help>$helptext</p>\n";
    }
    else {
	# mystery help request
	print "<p class=error>No help available on that topic.</p>\n";
    }
}

print "<p align=center><a href=javascript:close()>close</a></p>\n";
print "</td></tr></table>\n";
print "</body>\n";

### END

