#!/usr/bin/perl
#-----------------------------------------------------------------------
# logout.cgi
# (c) 2002 Exware
#-----------------------------------------------------------------------
#
#   Copyright 2001-2004 Exware Solutions, Inc.  http://www.exware.com
#
#   This file is part of ExSite WebWare (ExSite, for short).
#
#   ExSite is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   ExSite is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with ExSite; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#   Users requiring warranty coverage and/or support may arrange alternate
#   commercial licensing for ExSite, by contacting Exware Solutions 
#   via the website noted above.
#
#----------------------------------------------------------------------------

use ExSite::Config;
use ExSite::DB;
use ExSite::Section;
&exsite_init;
# unset the validation cookie
my $cookie_domain = $config{server}{host} ? ".$config{server}{domain}" : $config{server}{domain};
print "Set-cookie: $config{site}->{identity_cookie}=; path=$config{server}->{CGIpath}; domain=$cookie_domain; Expires=Thu, 01-Jan-1970 00:00:00 GMT\n";

# return user to the public homepage

my $url;
my $db = new ExSite::DB;  # no form/reporting tools needed
if ($ENV{HTTP_REFERER} =~ /page.cgi\?(.+\&)?_id=(\d+)/) {
    # return to homepage of site logged out from
    my $pid = $2;
    my $page = $db->fetch("page",$pid);
    if ($page->{section_id}) {
	my $site = new ExSite::Section(id=>$page->{section_id});
	# only go to website if it has been published
	my $diskpath = $site->diskpath;
	if (-e $diskpath) { 
	    $url = $site->get_url;
	}
    }
}
if (! $url) {
    # cannot find public homepage of the site they logged out from
    # return to homepage of the user's primary site
    my $s = $db->this_site;
    if ($s) {
	my $site = new ExSite::Section(section=>$s);
	my $diskpath = $site->diskpath;
	if (-e $diskpath) { 
	    $url = $site->get_url;
	}
    }
}
if (! $url) {
    # cannot find public homepage of the user's primary site
    # return to the system homepage
    $url = "$config{server}->{server}$config{server}{HTMLpath}";
}
print "Location: $url\n\n";
#### end

