#!/usr/bin/perl
#-----------------------------------------------------------------------
# webdb.cgi - general-purpose db admin tool
#
# This script acts as a front end to Modules::WebDB.
#-----------------------------------------------------------------------
#
#   Copyright 2001-2004 Exware Solutions, Inc.  http://www.exware.com
#
#   This file is part of ExSite WebWare (ExSite, for short).
#
#   ExSite is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   ExSite is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with ExSite; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#   Users requiring warranty coverage and/or support may arrange alternate
#   commercial licensing for ExSite, by contacting Exware Solutions 
#   via the website noted above.
#
#----------------------------------------------------------------------------

use strict;
use ExSite::Config;
#use ExSite::Misc;
#use ExSite::Form;
use Modules::WebDB;

&exsite_init;
my $db = new ExSite::Form;
my $wdb = new Modules::WebDB;

# undo default WebDB link configuration
$config{form}{mode} = $config{report}{linkmode} = "cgi";

# setup ctrl-panel-style header
my $help;
if (-e "$config{server}{HTMLroot}$config{server}{HTMLpath}/_Modules/WebDB/help.html") {
    $help = "<a href=\"javascript:popup_help('$config{server}{CGIpath}/exsite-help.cgi')\">help</a>";
}
my $header = "<table width=\"100%\" cellspacing=0 cellpadding=0 border=0>
<tr><td rowspan=2><img src=\"$config{server}{HTMLpath}/_Modules/WebDB/icon.gif\" align=\"left\"></td>
<td class=titlebar_noborder><span class=\"title\">WebDB</span><br>
The Database Manager provides functions for searching, browsing, editing, 
and adding records to any of the tables in your website's database. It is 
an expert-level tool that gives you the ability to \"hack\" your 
website's data.
</td>
</tr>
<tr><td valign=bottom align=right class=titlebar_noborder>
$help &nbsp;&nbsp;
<a href=\"$config{server}{CGIpath}/home.cgi\">close</a> 
</td></tr></table>\n";

&page_header("WebDB - $config{site}{name}",1);
print "<div align=\"center\">
<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"90%\" class=\"framed\">
      <tbody><tr>
        <td class=\"titlebar\">
$header
        </td>
      </tr>
      <tr>
        <td bgcolor=\"white\"><div class=\"htmlbox\">\n";

if ($db->authorize < $config{auth}{root_auth_level} - 1) {
    print "<h3 class=error>Permission denied</h3><p>You do not have sufficient system priveleges to use this feature.</p>\n";
}
else {
    print $wdb->write;
}

print "        </div></td>
      </tr>
    </tbody></table>
</div>
<br>\n";

&page_footer(1);
